﻿Type=Activity
Version=2.30
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim bConnected As Boolean
	Dim sFriendlyName As String
	Dim MacAddress As String

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim btnSend As Button
	Dim txtLog As EditText
	Dim txtSend As EditText
	Dim Label1 As Label
	Dim chkParseOutgoing As CheckBox
	Dim pnlSettings As Panel
	Dim Awake As PhoneWakeState
	Dim btnClearLog As Button
	Dim btnSave As Button

End Sub

Sub Activity_Create(FirstTime As Boolean)
	Main.phn.SetScreenOrientation(1)  'set screen orientation to portrait

	Activity.LoadLayout("BTMain")
	
	txtSend.Color = Colors.White
	txtLog.Color = Colors.White

	pnlSettings.Initialize("")
	pnlSettings.LoadLayout("BTSettings")
	Activity.AddView(pnlSettings,0,0,100%x,100%y)
	pnlSettings.Visible=False
	
	If FirstTime Then
		Activity.Title = "GSight Bluetooth"
	End If

	Activity.AddMenuItem("Connect", "mnuConnect")
	Activity.AddMenuItem("Disconnect", "mnuDisconnect")
	Activity.AddMenuItem("Settings", "mnuSettings")
	Activity.AddMenuItem("Save", "mnuSave")
	Activity.AddMenuItem("Clear", "mnuClear")
	Activity.AddMenuItem("Exit", "mnuExit")
End Sub

Sub Activity_Resume
	txtLog.Color = Colors.White
	txtSend.Color = Colors.White

	If bConnected = True Then
	
'		Awake.KeepAlive(True)
'		txtLog.Text = txtLog.Text & BTSerial.sLog' & CRLF
'		txtLog.SelectionStart = txtLog.Text.Length
'		BTSerial.sLog = ""
	End If
	
End Sub

Sub mnuSettings_Click
	pnlSettings.Visible = True
End Sub

Sub mnuSave_Click
	If File.ExternalWritable = False Then
		Msgbox("Unable to save files. External SD card is either locked or not present", _
			"GSight")
		Return
	End If
	
	Dim id As InputDialog
	id.InputType = id.INPUT_TYPE_TEXT
	Dim ret As Int
	ret = id.Show("Save LogFile as", "GSight","Save", "Cancel", "", Null)	
	Dim sFName As String
	sFName = id.Input
	
	If ret <> -1 Then
		Return
	End If
	If sFName = "" Then
		Msgbox("File name was blank", "File not Saved!")
		Return
	End If
	
	File.WriteString(File.DirRootExternal,sFName & ".txt",txtLog.Text)
	
	ToastMessageShow("File " & QUOTE & sFName & ".txt" & QUOTE & " saved", False)	
	
End Sub

Sub mnuConnect_Click
	Dim Serial1 As Serial
	Serial1.Initialize("Serial1")
	If Serial1.IsEnabled = False Then
		Msgbox("Please enable Bluetooth before attempting to connect.", "")
		Return
	End If
	Dim PairedDevices As Map
	PairedDevices = Serial1.GetPairedDevices
	Dim lst As List
	lst.Initialize
	For i = 0 To PairedDevices.Size - 1
		lst.Add(PairedDevices.GetKeyAt(i))
	Next
	Dim res As Int
	res = InputList(lst, "Choose device", -1) 'show list with paired devices
	If res <> DialogResponse.CANCEL Then
		Label1.Text = "Attempting connection..."
		MacAddress = PairedDevices.Get(lst.Get(res)) 'convert the name to mac address
		sFriendlyName = PairedDevices.GetKeyAt(res)
		
		StartService(BTSerial)
	End If
	
End Sub

Sub mnuExit_Click
'	Dim result As Int
'	result = Msgbox2("Are you sure you want to completely exit?", "GSight", "Yes", _
'		"Cancel", "", Null)'LoadBitmap(File.DirAssets, "smiley.gif"))
'	If result = DialogResponse.Positive Then
'		Activity_Pause(True)
		Activity.Finish
'	End If
	
End Sub

Sub PostData(message)
	txtLog.Text = txtLog.Text & message' & CRLF
	txtLog.SelectionStart = txtLog.Text.Length
End Sub

Sub mnuDisconnect_Click
	BTSerial.AStreams.Close
	BTSerial.Serial1.Disconnect
	bConnected = False
	StopService(BTSerial)
	Awake.KeepAlive(False)
End Sub

Sub btnSend_Click
	If BTSerial.AStreams.IsInitialized = False Then Return
  If txtSend.Text.Length > 0 Then
		Dim i As Int
		Dim s As String
		s = ""
		For i = 0 To txtSend.Text.Length-1
			If txtSend.Text.CharAt(i) = "#" Then
				Dim b As Byte
				Try
					b = txtSend.Text.CharAt(i+1) & txtSend.Text.CharAt(i+2) & _
						txtSend.Text.CharAt(i+3)
					s = s & Chr(b)
					i = i+3
					Catch
					b = txtSend.Text.CharAt(i+1) & txtSend.Text.CharAt(i+2)
					s = s & Chr(b)
					i = i+2
				End Try
			Else
					s = s & txtSend.Text.CharAt(i)
			End If
		Next				
			
  	Dim buffer() As Byte
		buffer = s.GetBytes("UTF8")
  	BTSerial.AStreams.Write(buffer)
   	txtSend.SelectAll
    Log("Sending: " & txtSend.Text)
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	Awake.ReleaseKeepAlive
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	If KeyCode=KeyCodes.KEYCODE_BACK Then
		'svSettings.Visible=False
		pnlSettings.Visible=False
		Return True
	End If
	
End Sub

Sub btnClearLog_Click
	txtLog.Text  = ""'txtLog.Text & msg' & CRLF
	'txtLog.SelectionStart = txtLog.Text.Length
End Sub

